<?php

class LocalImages extends Page {

	public function addImageTracking($id) {
        #$ee=8/0;
        debug::log("id=$id");
        // ----
        // Adds the folder file record.
        // ----
        global $localimages_folder;
        debug::log("localimages_folder=$localimages_folder");
        $folderObject=Folder::findOrMake($localimages_folder);
        // ----
        // Gets the URLs to convert
        // ----
        $urls_to_convert=array();
        $row=DataObject::get_by_id("SiteTree", "$id");
        $html=$row->Content;
        $urls=self::returnImageLinks($html);
        if(!empty($urls))$urls=array_unique($urls);
        foreach($urls as $url){
            if(stristr($url,'http'))$urls_to_convert[]=$url;
        }
        debug::log("urls_to_convert=".implode(' ~~ ',$urls_to_convert));
        // ----
        foreach($urls_to_convert as $url){
            $image_url=$url;
            debug::log("now retrieving content for image_url=$image_url");
            // ----
            // Gets the image content
            // ----
            $image_content=self::returnFileContent($image_url);
            $image_length=strlen($image_content);
            debug::log("image size=".$image_length);
            if($image_length>0){
                // ----
                // Creates the image file.
                // ----
                extract(parse_url($image_url));
                extract(pathinfo($path));
                $name=date("Ymd_His").'.'.$extension;
                $filename=$folderObject->filename.$name;
                debug::log("filename=$filename");
                $pathname=Director::baseFolder().'/'.$filename;
                debug::log("pathname=$pathname");
                $result=file_put_contents($pathname,$image_content);
                debug::log("put result=$result");
                // ----
                // Adds the image file record.
                // ----
		        $exists=DataObject::get_one('Image',"`Name`='$name'");
                $file_id=0;
                if($image_content && !$exists){
		            $myImage=new Image();
		            $myImage->Name=$this->$name;
		            $myImage->Title=$name;
		            $myImage->Filename=$filename;
		            $myImage->ParentID=$folderObject->ID;
                    $myImage->OwnerID=Member::currentUserID(); // Assigns current user as Owner
		            $file_id=$myImage->write();
		            debug::log("image does not exist, file_id written=$file_id");
                }else if($image_content && $exists ){
		            debug::log("image already exists");
		        }else{
			        debug::log("failed to add image file record for image_url=$image_url");
		        }
                if(!empty($file_id)){
                    // ----
                    // Adds the sitetree_imagetracking record
                    // ----
                    $last_id1=DB::query("select ID as last_id from SiteTree_ImageTracking order by ID desc limit 1")->value();
                    debug::log("last_id before SiteTree_ImageTracking insert=$last_id1");
                    DB::query("insert into SiteTree_ImageTracking(SiteTreeID,FileID,FieldName) values($id,$file_id,'Content')");
                    $last_id2=DB::query("select ID as last_id from SiteTree_ImageTracking order by ID desc limit 1")->value();
                    debug::log("last_id after SiteTree_ImageTracking insert=$last_id2");
                    if($last_id2-$last_id1==1){
                        // ----
                        // Changes the link in the HTML
                        // ----
                        $old_link=$url;
                        debug::log("old_link=$old_link");
                        $new_link=$filename;
                        debug::log("new_link=$new_link");
                        $html=str_ireplace("'","''",str_ireplace($old_link,$new_link,$html));
                        $sql="UPDATE SiteTree set Content='$html' where ID=$id";
                        debug::log("sql=$sql");
                        DB::query($sql);
                        $affected=DB::affectedRows();
                        debug::log("affected in SiteTree update=$affected");
                    }
                }
            }
        }
        return;
	}

    function returnImageLinks($html){
        $links=array();
        $doc=new DOMDocument();
        $doc->loadHTML($html);
        $elements=$doc->getElementsByTagName('img');
        for($i=0;$i<$elements->length;$i++){
            $src=$elements->item($i)->getAttribute('src');
            $links[]=$src;
        }
        return $links;
    }

    function returnFileContent($page_url){
        $page_url=self::returnURLWithEncodedQuery($page_url);
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, "$page_url");
        curl_setopt($ch,CURLOPT_SSL_VERIFYPEER,0);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
        curl_setopt($ch, CURLOPT_MAXREDIRS, 10);
        // Spoofs the User-Agent header value; just to be safe
        curl_setopt($ch, CURLOPT_USERAGENT,
        'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 5.1; Q312461; .NET CLR 1.1.4322; .NET CLR 2.0.50727)');
        // Sets the timeout values for both the connection and the download
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 20);
        curl_setopt($ch, CURLOPT_TIMEOUT, 30);
        // Ensures 404 Not Found (and similar) will be treated as errors
        curl_setopt($ch, CURLOPT_FAILONERROR, false);
        // Helps guard against accidentally downloading mp3 files and such, but it doesn't really work.
        $header[] = "Accept: text/html, text/*";
        curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
        // Downloads the content
        $html = curl_exec($ch);
        curl_close($ch);
        if(!$html) return false;
        $html=html_entity_decode($html);
        return $html;
    }

    function returnURLWithEncodedQuery($url){
        if(!stristr($url,'=')){
            return $url;
        }else{
            // Extracts the query
            $parts=parse_url($url);
            extract($parts);
            // Encodes the query
            $array=explode("=",$query);
            $array[1]=urlencode(urldecode($array[1]));
            $new_query=implode("=",$array);
            // Replaces the query with the encoded query
            $new_url=str_ireplace($query,$new_query,$url);
            // Returns the URL with the encoded query
            return $new_url;
        }
    }

}
